Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tree.iter
Class AxisIteratorImpl

    java.lang.Object
      net.sf.saxon.tree.iter.AxisIteratorImpl

All Implemented Interfaces:
  SequenceIterator, AxisIterator, UnfailingIterator

Direct Known Subclasses:
  Navigator.AxisFilter, Navigator.BaseEnumeration, Navigator.EmptyTextFilter

    public abstract class AxisIteratorImpl

extends Object
implements AxisIterator

A SequenceIterator is used to iterate over a sequence. An AxisIterator is a SequenceIterator that always iterates over a set of nodes, and that throws no exceptions; it also supports the ability to find the last() position, again with no exceptions. This class is an abstract implementation of AxisIterator that is used as a base class for many concrete implementations. The main functionality that it provides is maintaining the current position.

Field Summary
`protected NodeInfo` | `current`
`protected int` | `position`

Fields inherited from interface net.sf.saxon.om.SequenceIterator
`GROUNDED, LAST_POSITION_FINDER, LOOKAHEAD`

Constructor Summary
`AxisIteratorImpl()`

Method Summary
`Value` | `atomize()` Return the atomized value of the current node.
`void` | `close()` Close the iterator.
`NodeInfo` | `current()` Get the current node in the sequence.
`int` | `getProperties()` Get properties of this iterator, as a bit-significant integer.
`CharSequence` | `getStringValue()` Return the string value of the current node.
`AxisIterator` | `iterateAxis(byte axis, NodeTest test)` Return an iterator over an axis, starting at the current node.
`boolean` | `moveNext()` Move to the next node, without returning it.
`int` | `position()` Get the current position

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.saxon.tree.iter.AxisIterator
`getAnother, next`

Field Detail

### position

    protected int position

### current

    protected NodeInfo current

Constructor Detail

### AxisIteratorImpl

    public AxisIteratorImpl()

Method Detail

### moveNext

    public boolean moveNext()

  Move to the next node, without returning it. Returns true if there is a next node, false if the end of the sequence has been reached. After calling this method, the current node may be retrieved using the current() function.

  Specified by:
    `moveNext` in interface `AxisIterator`
  Returns:
    true if there is a next node, false if the end of the sequence has been reached

### current

    public NodeInfo current()

  Get the current node in the sequence.

  Specified by:
    `current` in interface `SequenceIterator`
  Specified by:
    `current` in interface `AxisIterator`
  Specified by:
    `current` in interface `UnfailingIterator`
  Returns:
    the node returned by the most recent call on next()

### position

    public final int position()

  Get the current position

  Specified by:
    `position` in interface `SequenceIterator`
  Specified by:
    `position` in interface `UnfailingIterator`
  Returns:
    the position of the most recent node returned by next()

### close

    public void close()

  Description copied from interface: `SequenceIterator`
  Close the iterator. This indicates to the supplier of the data that the client does not require any more items to be delivered by the iterator. This may enable the supplier to release resources. After calling close(), no further calls on the iterator should be made; if further calls are made, the effect of such calls is undefined.

  (Currently, closing an iterator is important only when the data is being "pushed" in another thread. Closing the iterator terminates that thread and means that it needs to do no additional work. Indeed, failing to close the iterator may cause the push thread to hang waiting for the buffer to be emptied.)

  Specified by:
    `close` in interface `SequenceIterator`

### iterateAxis

    public AxisIterator iterateAxis(byte axis,
                                    NodeTest test)

  Return an iterator over an axis, starting at the current node.

  Specified by:
    `iterateAxis` in interface `AxisIterator`
  Parameters:
    `axis` - the axis to iterate over, using a constant such as `Axis.CHILD`
    `test` - a predicate to apply to the nodes before returning them.
  Returns:
    an iterator over an axis, starting at the current node

### atomize

    public Value atomize()
                  throws XPathException

  Return the atomized value of the current node.

  Specified by:
    `atomize` in interface `AxisIterator`
  Returns:
    the atomized value.
  Throws:
    `NullPointerException` - if there is no current node
    `XPathException` - if the current node cannot be atomized, for example because it is an element node with element-only content.

### getStringValue

    public CharSequence getStringValue()

  Return the string value of the current node.

  Specified by:
    `getStringValue` in interface `AxisIterator`
  Returns:
    the string value, as an instance of CharSequence.
  Throws:
    `NullPointerException` - if there is no current node

### getProperties

    public int getProperties()

  Get properties of this iterator, as a bit-significant integer.

  Specified by:
    `getProperties` in interface `SequenceIterator`
  Returns:
    the properties of this iterator. This will be some combination of properties such as `SequenceIterator.GROUNDED`, `SequenceIterator.LAST_POSITION_FINDER`, and `SequenceIterator.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.